package net.cattaka.rdbassistant.jspf.standard;

import java.io.PrintWriter;
import java.sql.SQLException;

import net.cattaka.rdbassistant.jspf.JspfConstants;
import net.cattaka.rdbassistant.jspf.core.JspfBase;
import net.cattaka.rdbassistant.jspf.core.JspfMessageException;
import net.cattaka.util.MessageBundle;

public class JspfBaseCreateInsertSql extends JspfBase {

	public JspfBaseCreateInsertSql() {
		this.setName(JspfConstants.JSPF_NAME_CREATE_INSERT_SQL);
		this.setDisplayName(MessageBundle.getMessage("create_insert_sql"));
	}
	
	@Override
	public void runJspf(PrintWriter out) throws SQLException, JspfMessageException {
		out.println("INSERT INTO");
		if (selectionInfo.getTables().length == 1) {
			out.println("\t" + selectionInfo.getTables()[0]);
		} else {
			error(MessageBundle.getMessage("select_single_table"));
		}
		
		// VALUESを作成
		String[] columns = selectionInfo.getColumns(); 
		if (columns.length > 0) {
			out.print("(\n");
			for (int i=0;i<columns.length;i++) {
				if (i>0) {
					out.print(",\n");
				}
				out.print("\t"+columns[i]);
			}
			out.print("\n)\n");
			out.print("VALUES\n(\n");
			for (int i=0;i<columns.length;i++) {
				if (i<columns.length-1) {
					out.print("\t\'\',\t/* "+columns[i] + " */\n");
				} else {
					out.print("\t\'\'\t/* "+columns[i] + " */\n");
				}
			}
			out.println(")");
		}
	}
}
